<template>
  <div class="app-container">
    <div class="filter-container">
      <div class="filter-control">
        <span style="width: auto;">主题:</span>
        <el-input
          v-model="listQuery.topic"
          placeholder="主题名称"
          clearable
          @keyup.enter.native="getList"
          @clear="getList"
        />
      </div>
      <div class="filter-control">
        <span style="width: auto;">状态:</span>
        <el-select v-model="listQuery.enabledStatus" style="width:120px;" clearable @change="getList">
          <el-option value="" label="请选择" />
          <el-option :value="1" label="已上线" />
          <el-option :value="0" label="已下线" />
        </el-select>
      </div>
      <div class="filter-control">
        <el-button type="primary" icon="el-icon-search" @click="getList">查询</el-button>
        <el-button type="primary" icon="el-icon-plus" @click="handleToEdit('add')">添加活动</el-button>
      </div>
    </div>
    <p style="margin: 0;line-height: 24px;font-size: 14px;color: #999;">注：专题仅支持一个已启用状态的活动。</p>
    <el-table
      v-loading="listLoading"
      :data="list"
      element-loading-text="Loading"
      border
      fit
      highlight-current-row
      :header-cell-style="{background:'#eef1f6',color:'#606266'}"
    >
      <el-table-column label="主题名称" align="center" prop="topic" />
      <el-table-column label="活动入口图片" align="center" prop="image" width="200">
        <template slot-scope="{row}">
          <el-popover
            placement="top-start"
            title=""
            width="370"
            trigger="hover"
          >
            <img :src="row.image" alt="" style="width:340px;height:180px;">
            <img slot="reference" :src="row.image" alt="" style="width:170px;height:90px;">
          </el-popover>
        </template>
      </el-table-column>
      <el-table-column class-name="status-col" label="状态" align="center" prop="enabledStatus">
        <template slot-scope="{row}">
          <el-tag v-if="row.enabledStatus===0" type="danger" size="small">已下线</el-tag>
          <el-tag v-else type="success" size="small">已上线</el-tag>
          <el-button v-if="row.enabledStatus === 0" type="primary" size="mini" @click="handleShangeStatus(row.id,row.enabledStatus)">上线</el-button>
          <el-button v-else type="primary" size="mini" @click="handleShangeStatus(row.id,row.enabledStatus)">下线</el-button>
        </template>
      </el-table-column>
      <el-table-column align="center" label="添加时间" prop="addTime">
        <template slot-scope="{row}">
          <span>{{ row.addTime | parseTime('{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="{row}">
          <el-button type="primary" size="mini" @click="handleToEdit('edit',row.id)">编辑</el-button>
          <el-button type="danger" size="mini" @click="handleDelete(row.id)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>20" :total="total" :page.sync="listQuery.index" :limit.sync="listQuery.pageSize" @pagination="getList" />

  </div>
</template>

<script>
import { getThemeList, getThemeStatus, delTheme } from '@/api/campaign'

export default {
  data() {
    return {
      list: null,
      listLoading: true,
      total: 0,
      listQuery: {
        index: 1,
        pageSize: 20,
        enabledStatus: '',
        organizeId: this.$store.getters.organizeId
      }
    }
  },
  computed: {

  },
  created() {
    this.getList()
  },
  methods: {
    // 获取专题列表
    async getList() {
      this.listLoading = true
      try {
        const res = await getThemeList(this.listQuery)
        this.list = res.data.results
        this.total = res.data.totalRecord
        this.listLoading = false
      } catch (error) {
        console.log('error', error)
      }
    },
    // 操作上下线
    handleShangeStatus(id, status) {
      let confirmTxt = ''
      console.log('status', status)
      if (status === 1) {
        confirmTxt = '确定下线该活动吗？下线后将从小程序隐藏。'
      } else {
        confirmTxt = '确定上线该活动吗？上线后将重新在小程序显示。'
      }
      this.$confirm(confirmTxt).then(_ => {
        this.getThemeStatus(id)
      }).catch(() => {
        this.getList()
      })
    },
    // 上下线专题
    async getThemeStatus(id) {
      try {
        await getThemeStatus(id)
        this.$message({ message: '操作成功', type: 'success' })
        this.getList()
      } catch (error) {
        console.log('error', error)
      }
    },
    // 删除专题
    handleDelete(id) {
      this.$confirm('确定删除该专题活动吗？').then(_ => {
        this.delTheme(id)
      })
    },
    async delTheme(id) {
      try {
        await delTheme(id)
        this.$message({ message: '操作成功', type: 'success' })
        this.getList()
      } catch (error) {
        console.log('error', error)
      }
    },
    // 跳转添加/编辑
    handleToEdit(type, id) {
      if (type === 'add') {
        this.$router.push({ path: '/campaign/special-edit', query: { type: type }})
      } else {
        this.$router.push({ path: '/campaign/special-edit', query: { type: type, id: id }})
      }
    }
  }
}

</script>
<style>
.el-input-number.is-controls-right .el-input__inner {
    padding-left: 5px;
    padding-right: 30px;
}
</style>
<style lang="scss" scoped>
.filter-title{
  float: left;
  font-size: 12px;
  line-height: 18px;
  text-align: left;
  color: #2E3748;
}
.filter-title p{
  margin:10px 0;
}
</style>
